http://www.cnblogs.com/freezhan/archive/2013/03/15/2974230.html
http://www.hankcs.com/program/cpp/poj-3280-cheapest-palindrome.html
f(i+1,j)+删除第i个字符的代价
public static void main(String[] args) {
Scanner in = new Scanner(System.in);
int N = in.nextInt();
int M = in.nextInt();
String s = in.next();
int[][] dp = new int[M][M];
for (int i = 0; i < N; i++){
char c = in.next().charAt(0);
int add = in.nextInt();
int delete = in.nextInt();
cost[c-'a'] = Math.min(add, delete);
}
char[] ss = s.toCharArray();
for (int i = M - 1; i >= 0; i--) {
for (int j = i + 1; j < M; j++) {
dp[i][j] = Math.min(dp[i + 1][j] + cost[ss[i] - 'a'],
dp[i][j - 1] + cost[ss[j] - 'a']);
if (ss[i] == ss[j]) {
dp[i][j] = Math.min(dp[i][j], dp[i + 1][j - 1]);
}
}
}
System.out.println(dp[0][M-1]);
}
Keeping track of all the cows can be a tricky task so Farmer John has installed a system to automate it. He has installed on each cow an electronic ID tag that the system will read as the cows pass by a scanner. Each ID tag's contents are currently a single string with length M (1 ≤ M ≤ 2,000) characters drawn from an alphabet of N (1 ≤ N ≤ 26) different symbols (namely, the lower-case roman alphabet).
Cows, being the mischievous creatures they are, sometimes try to spoof the system by walking backwards. While a cow whose ID is "abcba" would read the same no matter which direction the she walks, a cow with the ID "abcb" can potentially register as two different IDs ("abcb" and "bcba").
FJ would like to change the cows's ID tags so they read the same no matter which direction the cow walks by. For example, "abcb" can be changed by adding "a" at the end to form "abcba" so that the ID is palindromic (reads the same forwards and backwards). Some other ways to change the ID to be palindromic are include adding the three letters "bcb" to the begining to yield the ID "bcbabcb" or removing the letter "a" to yield the ID "bcb". One can add or remove characters at any location in the string yielding a string longer or shorter than the original string.
Unfortunately as the ID tags are electronic, each character insertion or deletion has a cost (0 ≤ cost ≤ 10,000) which varies depending on exactly which character value to be added or deleted. Given the content of a cow's ID tag and the cost of inserting or deleting each of the alphabet's characters, find the minimum cost to change the ID tag so it satisfies FJ's requirements. An empty ID tag is considered to satisfy the requirements of reading the same forward and backward. Only letters with associated costs can be added to a string.
Input
Line 1: Two space-separated integers: N and M
Line 2: This line contains exactly M characters which constitute the initial ID string
Lines 3..N+2: Each line contains three space-separated entities: a character of the input alphabet and two integers which are respectively the cost of adding and deleting that character.
Line 2: This line contains exactly M characters which constitute the initial ID string
Lines 3..N+2: Each line contains three space-separated entities: a character of the input alphabet and two integers which are respectively the cost of adding and deleting that character.
Output
Line 1: A single line with a single integer that is the minimum cost to change the given name tag.
Sample Input
3 4 abcb a 1000 1100 b 350 700 c 200 800
Sample Output
900
Hint
If we insert an "a" on the end to get "abcba", the cost would be 1000. If we delete the "a" on the beginning to get "bcb", the cost would be 1100. If we insert "bcb" at the begining of the string, the cost would be 350 + 200 + 350 = 900, which is the minimum.
http://www.hankcs.com/program/cpp/poj-3280-cheapest-palindrome.html
字串S长M,由N个小写字母构成。欲通过增删字母将其变为回文串,增删特定字母花费不同,求最小花费。
定义dp[i][j]表示将原字串s的子字串s[i…j]变换成回文的最小花费,满足如下递推关系式:
dp[i][j] = min( dp[i + 1][j] + cost[s[i] - 'a'], // 比i, j少了一个首字母 dp[i][j - 1] + cost[s[j] - 'a']); // 比i, j少了一个尾字母 if (s[i] == s[j]) { // 首尾相同,等于少了首尾 dp[i][j] = min(dp[i][j], dp[i + 1][j - 1]); }
注意此处的可以增加也可以删除是个局,取其花费最小值即可。因为如果在首尾增删字母x都可以使一个字串s[i…j]变成回文的话,当然选取花费小的。
另一个注意点是两重循环的方向,起点i应当趋0,终点j应当趋M。
分析:经典DP。是poj1159的加强版本,增加了删除操作,而且每次插入删除的代价也不一定为一个恒定值,但是大体上的思路是一样的:设dp[i][j]表示将i--j变成回文串的最小代价。
插入操作在我的上上篇博文有讲,这里不再多赘述。
删除操作的状态很好表示:f(i,j-1)+ 删除第j个字符的代价
区间DP,在做leetcode时,也遇到了很多相关的回文DP,题目的意思是让我们求删和加得到最新回文的代价最小。
- 1
- 2
- 3
- 4
- 5
- 1
- 2
- 3
- 4
- 5
如
abcb
有很多种做法如1. abcba 2. bcbabcb
,在这里显然bcbabca
最小。
主要思想:
- 遍历顺序:
- 1
- 2
- 3
- 4
- 5
- 6
- 7
- 8
- 9
- 10
- 11
- 1
- 2
- 3
- 4
- 5
- 6
- 7
- 8
- 9
- 10
- 11
- 判断条件:(
ss[i] == ss[j]
)
首尾元素相等,可以忽略不看。